<?php
include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/../../init.php');
require_once _PS_MODULE_DIR_.'alfred/classes/Api.php';



$action  = Tools::getValue('action');
$getbestcourier_data = Tools::getValue('getbestcourier_data');
$order_id = Tools::getValue('order_id');

$order = new Order($order_id);
$id_cart = $order->id_cart;
$customer = new Customer($order->id_customer);

$address_delivery = new Address($order->id_address_delivery);
$address_invoice = new Address($order->id_address_invoice);

$state_delivery = new State((int) $address_delivery->id_state);
$state_invoice = new State((int) $address_invoice->id_state);

$country_iso_invoice = Country::getIsoById($address_invoice->id_country);

$country_iso_delivery = Country::getIsoById($address_delivery->id_country);

$state_sender = new State((int) Configuration::get('PS_SHOP_STATE_ID', null, null, $order->id_shop));
$country_sender = Country::getIsoById(Configuration::get('PS_SHOP_COUNTRY_ID', null, null, $order->id_shop));

$message = $order->getFirstMessage();

if ($action == 'get_bestcourier') {
	
	$colli = '';
	foreach ($getbestcourier_data as $key => $value) {
	    $colli[] = array (
	        "altezza" => (int)$value['height'],
	        "larghezza" => (int)$value['width'],
	        "profondita" => (int)$value['depth'],
	        "peso" => (int)$value['weight'],
	    );
	}

    $data = array (	    
	    "private" => 0,
	    "from_citta" => (string)$address_invoice->city,
	    "from_zipcode" =>  (string)$address_invoice->postcode,
	    "from_provincia" => (string)$state_invoice->iso_code,
	    "dest_citta" => (string)$address_delivery->city,
	    "dest_zipcode" =>  (string)$address_delivery->postcode,
	    "dest_provincia"=> (string)$state_delivery->iso_code,
	    "from_nazione" => (string)$country_iso_invoice,
	    "dest_nazione" => (string)$country_iso_delivery,
	    "colli" => $colli,
	    "tipologia" => "WALLET",
	    "varie" => "",
        "apitoken" => true,
	);

	$alfredApi = new AlfredApi;
	$response1 = $alfredApi->send('v3/GetBestCourier.php', $data);
	echo json_encode($response1['payload']);
	exit();
}


if ($action=='enable_disable_point'){

    $status  = Tools::getValue('status');
   
    $message="Point enabled";
    if($status==0) $message="Point disabled";

    $updateCarrierStatus = "update ps_carrier set active=".$status." where name='Alfred24'";
    Db::getInstance()->execute($updateCarrierStatus);

    $response=array("response"=>200,"status"=>$status,"message"=>$message);
    echo json_encode($response);
	exit();
}


if ($action == 'create_shippment') {
	$parcels ='';
	$idPoint =  Db::getInstance()->getValue('Select idPoint from '. _DB_PREFIX_ .'alfred_pick_point where id_cart='.$id_cart);

	$services = Tools::getValue('services');
	$price = '';
	if($idPoint) {
		$price = Tools::getValue('price_point');
	} else {
		$price = Tools::getValue('price_not_point');
	}
	
	$corriere = Tools::getValue('corriere');

    $sender = array (
        "name" => (string)Configuration::get('PS_SHOP_NAME', null, null, $order->id_shop),
        "address" => (string)Configuration::get('PS_SHOP_ADDR1', null, null, $order->id_shop),
        "zip" => (string)Configuration::get('PS_SHOP_CODE', null, null, $order->id_shop),
        "location" => (string)Configuration::get('PS_SHOP_CITY', null, null, $order->id_shop),
        "province" => (string)$state_sender->iso_code,
        "country" => (string)$country_sender,
        "phone" => (string)Configuration::get('PS_SHOP_PHONE', null, null, $order->id_shop),
        "email" => (string)Configuration::get('PS_SHOP_EMAIL', null, null, $order->id_shop)
    );
    $receiver = array (
        "name" => (string)$customer->firstname,
        "address" => (string)$address_delivery->address1,
        "zip" => (string)$address_delivery->postcode,
        "location" => (string)$address_delivery->city,
        "province" => (string)$state_delivery->iso_code,
        "country" => (string)$country_iso_delivery,
        "phone" => (string)$address_delivery->phone,
        "email" => (string)$customer->email
    );

    foreach ($getbestcourier_data as $key => $value) {
        $parcels[] = array (
            "height" => (int)$value['height'],
            "width" => (int)$value['width'],
            "depth" => (int)$value['depth'],
            "weight" => (int)$value['weight']
        );
    }

     $shipment = array(
        "date" => (string)Tools::displayDate($order->date_add),
        "content" => "string",
        "note" => (string)$message,
        "cashOnDelivery" => 0,
        "insurance" => 0,
        "parcels" => $parcels,
        "services" => (string)$services,
        "price" => (string)$price,
    );


    $data =  array (        
        "selected_point" => (string)$idPoint,
        "courier" => (string)$corriere,
        "sender" => $sender,
        "receiver" => $receiver,
        "shipment" => $shipment,
        "apitoken" => true,
    );


    print_r($data);



    $alfredApi = new AlfredApi;
	$response2 = $alfredApi->send('v3/CreateShipmentNew.php', $data);


    if (isset($response2['payload']['urlLabel'])) {
        $urlLabel = $response2['payload']['urlLabel'];

        $existing_id = Db::getInstance()->executeS('Select * from ' . _DB_PREFIX_ . 'alfred_urlLabel where id_order='.$order_id);

        if($existing_id) {
			Db::getInstance()->execute("UPDATE ". _DB_PREFIX_ . "alfred_urlLabel  SET urlLabel = '".$urlLabel."' where id_order=".$order_id);
		} else {
        	Db::getInstance()->execute('INSERT INTO ' . _DB_PREFIX_ . 'alfred_urlLabel (id_order, urlLabel) VALUES("'.$order_id.'","'.$urlLabel.'")');
        }

        $order_obj = $order;
        $order_rows = [];
        $order_items = [];
        foreach ($order->getProducts() as $order_product) {
            $order_rows[] = array(
                'id' => $order_product['id_order_detail'],
                'product_id' => $order_product['product_id'],
                'product_attribute_id' => $order_product['product_attribute_id'],
                'product_quantity' => $order_product['product_quantity'],
                'product_name' => $order_product['product_name'],
                'product_reference' => $order_product['product_reference'],
                'product_ean13' => $order_product['product_ean13'],
                'product_isbn' =>  $order_product['product_isbn'],
                'product_upc' =>  $order_product['product_upc'],
                'product_price' =>  $order_product['product_price'],
                'id_customization' => $order_product['id_customization'],
                'unit_price_tax_incl' => $order_product['unit_price_tax_incl'],
                'unit_price_tax_excl' => $order_product['unit_price_tax_excl'],
            );

            $order_items[] = array(
                'order_id' => $order->id,
                'product_name' => $order_product['product_name'],
                'qty' => $order_product['product_quantity'],
            );
        }

        $order_obj->associations = array(
            'order_rows' => $order_rows
        );

        $order_obj->receiver = array(
            'alias' => $address_delivery->alias,
            'company' => '',
            'lastname' => $address_delivery->lastname,
            'firstname' => $address_delivery->firstname,
            'vat_number' => '',
            'address1' => $address_delivery->address1,
            'address2' => $address_delivery->address2,
            'postcode' => $address_delivery->postcode,
            'city' => $address_delivery->city,
            'province' => 'FE',
            'state' => 'IT',
            'phone' => $address_delivery->phone,
            'phone_mobile' => $address_delivery->phone_mobile,
            'email' => $customer->email
        );

        $order_obj->items = $order_items;

        $data = array(
            'alfred_token' => true,
            'prestashop_token' => Configuration::get('ALFRED_SHOP_TOKEN'),
            'platform_id_order' => 14,
            'order_object' => $order_obj            
        );

        $alfredApi = new AlfredApi;
        $response = $alfredApi->send('v1/prestashop/InsertOrder.php', $data);
    }

    echo json_encode($response2);
	exit();
    
} elseif ($action == 'check-wallet') {
    $alfredApi = new AlfredApi;
    $data['apitoken'] = true;
    $response = $alfredApi->send('v3/CheckTotalWallet.php', $data);
    die(Tools::jsonEncode($response));    
}