<?php

class AlfredMerchant
{
    public static function registerStore()
    {
        $shop_token = Tools::passwdGen(64);
        $data = [
            'alfred_token' => true,
            'prestashop_token' => $shop_token
        ];
        Configuration::updateValue('ALFRED_SHOP_TOKEN', $shop_token);
        $api = new AlfredApi();
        $api->send('plugins/v1/prestashop/auth.php', $data);        
    }

    public static function deAuth()
    {        
        $data = [
            'prestashop_token' => Configuration::get('ALFRED_SHOP_TOKEN'),
            'alfred_token' => true,
        ];        
        $api = new AlfredApi();
        return $api->send('plugins/v1/prestashop/de-auth.php', $data);        
    }

    public static function login($email, $password)
    {        
        $data = [            
            'user' => $email,            
            'password' => $password
        ];
        $api = new AlfredApi();
        return $api->send('wd/GetToken.php', $data);
    }

    public static function autoConfig($apiToken, $url, $tokenPrestashp){
        $data = [
            'apitoken'          => $apiToken,
            'url_shop'          => $url,
            'token_prestashop'  => $tokenPrestashp
        ];

        $api = new AlfredApi();
        return $api->send('plugins/v1/prestashop/AutoConfig.php', $data);
    }

    public static function registerUser(
        $email,
        $firstname,
        $lastname,
        $address,
        $company,
        $postcode,
        $locality,
        $province,
        $region,
        $phone,
        $password
    ) {
        $data = [
            'nome' => $firstname,
            'cognome' => $lastname,
            'az_email' => $email,
            'az_ragione_sociale' => $company,
            'az_indirizzo' => $address,
            'az_cap' => $postcode,
            'az_localita' => $locality,
            'az_provincia' => $province,
            'az_regione' => $region,
            'telefono' => $phone,
            'password' => $password
        ];
        $api = new AlfredApi();
        return $api->send('v3/CreateUser.php', $data);
    }

    public static function authenticate()
    {

    }
}
