
<?php
include_once(_PS_MODULE_DIR_.'alfred/classes/OrderAlfred.php');
class WebserviceSpecificManagementAlfredOrders implements WebserviceSpecificManagementInterface
{
    /** @var WebserviceOutputBuilder */

    protected $objOutput;
    protected $output;

    /** @var WebserviceRequest */
    protected $wsObject;

    public function setUrlSegment($segments)
    {
        $this->urlSegment = $segments;
        return $this;
    }

    public function getUrlSegment()
    {
        return $this->urlSegment;
    }

    public function getWsObject()
    {
        return $this->wsObject;
    }

    public function getObjectOutput()
    {
        return $this->objOutput;
    }

    /**
     * This must be return a string with specific values as WebserviceRequest expects.
     *
     * @return string
    */

    public function getContent()
    {
        return $this->objOutput->getObjectRender()->overrideContent($this->output);
    }

    public function setWsObject(WebserviceRequestCore $obj)
    {
        $this->wsObject = $obj;
        return $this;
    }

    /**
     * @param WebserviceOutputBuilderCore $obj
     * @return WebserviceSpecificManagementInterface
    */

    public function setObjectOutput(WebserviceOutputBuilderCore $obj)
    {
        $this->objOutput = $obj;
        return $this;
    }



    public function manage()
    {
        
        $objects_orders = []; 
        $objects_orders['empty'] = new OrderAlfred(); 
        $this->_resourceConfiguration = $objects_orders['empty']->getWebserviceParameters();
        $alfredStatus = $this->getAlfredStatus()[0]['id_order_state'];
        $order_list = Db::getInstance()->executeS('SELECT '._DB_PREFIX_.'orders.* ,'._DB_PREFIX_.'alfred_pick_point.pickup_point_details FROM '._DB_PREFIX_.'orders  LEFT JOIN  '._DB_PREFIX_.'alfred_pick_point 
        ON '._DB_PREFIX_.'orders.id_cart = '._DB_PREFIX_.'alfred_pick_point.id_cart
        WHERE current_state = '.$alfredStatus .'
        ORDER BY id_order;');  

        foreach ($order_list as $list) { 
            $order =  new OrderAlfred($list['id_order']);
            if (isset($list['alfred_pick_point'])) $order->point = $list['alfred_pick_point'];
            $objects_orders[] = $order; 
        }
        
        $fieldsToDisplay  = 'full'; // 'minimum', 'full'
        $schema           = ''; // 'synopsis' - show customer column details, 'blank', null
        $deep             = 2; // depth for the tree diagram output
        $override         = false;
        
        $this->output .= $this->objOutput->getContent($objects_orders,  $schema, $fieldsToDisplay, $deep, null, $override);
    }

    private function getAlfredStatus(){
        $alfredStatus = Db::getInstance()->executeS('SELECT id_order_state FROM '._DB_PREFIX_.'order_state_lang where name = \'Alfred_Status\' and id_lang = 1'); 
        return $alfredStatus;
    }
 
}

?>
