<?php


class AlfredSearchModuleFrontController extends ModuleFrontController
{
	public function postProcess()
	{
		if (!$this->context->cart->id || !$this->ajax) {
			Tools::dieOrLog('You are not allowed to access this page', true);
		}
	}

	public function displayAjaxSearch()
	{		
		$data =  array (
			'apitoken' 	=> '',
			'country' 	=> 'IT',
			'address' 	=> Tools::getValue('zipcode'),
			'services' 	=> array ("delivery" =>1),
			"distance"  => 10
		);

		$alfredApi = new AlfredApi;
		$response = $alfredApi->send('wd/GetPoints.php', $data);
		echo json_encode($response);
	}


	public function displayAjaxImportOrder()
	{		

		$order_id = Tools::getValue('order_id');
		$order = new Order($order_id);

		echo json_encode($order);

	}



	public function displayAjaxSavePickupPoint()
	{
		$id_cart = (int)$this->context->cart->id;
		$idPoint = Tools::getValue('idPoint');
		$pickup_point_details = Tools::getValue('pickup_point_details');

		$cart_pickup_point = Db::getInstance()->executeS('SELECT * FROM ' . _DB_PREFIX_ . 'alfred_pick_point WHERE id_cart = '.$id_cart);
		$data = array(
			'idPoint' => $idPoint,
			'pickup_point_details' => pSQL($pickup_point_details)
		);

		if ($cart_pickup_point) {
			Db::getInstance()->update(
				'alfred_pick_point',
				$data,				
				'id_cart = '.$id_cart
			);
		} else {
			$data['id_cart'] = $id_cart;

			Db::getInstance()->insert(
				'alfred_pick_point',
				$data
			);			
		}		
	}

	public function displayAjaxDeletePickupPoint()
	{		
		Db::getInstance()->delete(
			'alfred_pick_point',
			'id_cart = '.(int)$this->context->cart->id
		);
	}
 
}