<?php
/**
 * 2007-2019 PrestaShop and Contributors
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/OSL-3.0
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to https://www.prestashop.com for more information.
 *
 * @author    PrestaShop SA <contact@prestashop.com>
 * @copyright 2007-2019 PrestaShop SA and Contributors
 * @license   https://opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 * International Registered Trademark & Property of PrestaShop SA
 */

/**
 * @property Order $object
 */
class AdminOrdersController extends AdminOrdersControllerCore
{
    public function __construct()
    {
        parent::__construct();
        $this->_select .= ' , alu.urlLabel';
        $this->_join .= ' LEFT JOIN '._DB_PREFIX_.'alfred_urlLabel alu ON alu.id_order = a.id_order ';
        $this->fields_list = array_merge($this->fields_list, array(
                'urlLabel' => array(
                    'title' => $this->trans('Label', array(), 'Admin.Global'),
                    'align' => 'text-center',
                    'callback' => 'printLabelIcons',
                    'orderby' => false,
                    'search' => false,
                    'remove_onclick' => true,
                ),
            )
        );
    }

    public function printLabelIcons($label_url, $row)
    {
        if ($label_url) {
            return '<a class="btn btn-default _blank" href="'.$label_url.'" target="_blank">
                <i class="icon-file-text"></i>
            </a>';
        } else {
            return '';
        }        
    }
}
