/**
* 2007-2021 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    PrestaShop SA <contact@prestashop.com>
*  @copyright 2007-2021 PrestaShop SA
*  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*
* Don't forget to prefix your containers with your own identifier
* to avoid any conflicts with others containers.
*/





$( document ).ready(function() {

   $(document).on('click', '.alfred_delivery_option input[type="radio"]', function() {
        var alfred_option_value = $('input[name="alfred_options"]:checked').val();
        if(alfred_option_value == "alfred_option_2"){
            $('.pick_pointzip').show();
            $('.search_bar_zip').show();
        } else if(alfred_option_value == "alfred_option_1") {
            $('input#zipcode_search').val('');
            $('.pick_pointzip').html('');
            $.ajax({
                url: alfred_search_url,
                type: 'POST',
                data: {
                    action : 'deletePickupPoint',
                },
                success: function(response){
                    $('#alfred_pickupoint_error').hide();
                    $('button[name="confirmDeliveryOption"]').prop( "disabled", false );
                }
            });
            $('.pick_pointzip').hide();
            $('.search_bar_zip').hide();
        }
    });

   
    $(document).on('click', '.search_bar_zip span.searchzip_icon', function() {
        $.ajax({
            url: alfred_search_url,
            type: 'POST',
            data: {
                zipcode: $('input#zipcode_search').val(),
                action: 'search',
            },
            success: function(response){
                var resuslt = jQuery.parseJSON(response);
                var input_data ="";
                input_data +='<div class="pick_pointzip_details">';
                $.each(resuslt.items, function( index, value ) {
                    var pickup_point_details = JSON.stringify(value);
                    input_data += "<label class='point_zip radio-block'>\
                                <span class='custom-radio'>\
                                <input type='radio' class='pickup_point_zip' name='pickup_point_zip' data-pickup_point_details='"+pickup_point_details+"' value='"+value.idPoint+"'>\
                                <span></span>\
                                </span>\
                                <span class='pickup_point_heading'><b>"+value.pointName+"</b></span><br />\
                                <span class='pickup_point_sub_heading'>"+value.pointAddress+", "+value.pointZip+", "+value.pointCity+" - <i>"+Number.parseFloat(value.distance).toFixed(2)+" Km distante</i></span>\
                            </label><br />";
                });
                input_data +='</div>';
                $('.pick_pointzip').html(input_data);

                //? click to search pick up by input

                $("input[name='pickup_point_zip']").click(function(){
                    var idPoint = $(this).val();
                    var pickup_point_details = $(this).attr('data-pickup_point_details');
                    $.ajax({
                        url: alfred_search_url,
                        type: 'POST',
                        data:{
                            idPoint: idPoint,
                            pickup_point_details: pickup_point_details,
                            action: 'savePickupPoint',
                        },
                        success: function(response){
                            $('#alfred_pickupoint_error').hide();
                            $('button[name="confirmDeliveryOption"]').prop( "disabled", false );
                        }
                    });
                });
            }
        });
    });

    $("button[name='confirmDeliveryOption']" ).click(function() {
        validatePickupPoint();
    });


    $("#payment-confirmation").click(function(event) {

            console.log("confirmation")
            $.ajax({
                url: alfred_search_url,
                type: 'POST',
                data: {
                    action: 'importOrder',
                },
                success: function(response){
                   //console.log(response);
                }
            });

            event.preventDefault();
    });




    function validatePickupPoint() {
        var errors = '';
        var alfred_option_value = $('input[name="alfred_options"]:checked').val();
        if(alfred_option_value == "alfred_option_2") { 
            var pickup_point_value = $('input[name="pickup_point_zip"]:checked').val();
            if (typeof pickup_point_value == "undefined") {
                errors = 'Seleziona un point dall\'elenco';
            }
        } else if(alfred_option_value == "alfred_option_1") {
            $('input#zipcode_search').val('');
            $('.pick_pointzip').html('');
            $.ajax({
                url: alfred_search_url,
                type: 'POST',
                data:{
                    action: 'deletePickupPoint',
                },
                success: function(response){
                    $('#alfred_pickupoint_error').hide();
                    $('button[name="confirmDeliveryOption"]').prop( "disabled", false );
                    return true;
                }
            });
            $('.pick_pointzip').hide();
            $('.search_bar_zip').hide();
        }

        if (errors.length > 0) {
            showErrors(errors);
        } else {
            $('button[name="confirmDeliveryOption"]').prop( "disabled", false );
            return true;
        }
    }

    function showErrors(errors) {
        $('#alfred_pickupoint_error').show();
        $('#alfred_pickupoint_error').html(errors);
        $('button[name="confirmDeliveryOption"]').attr('disabled', 'disabled');
        
        document.getElementById("alfred_pickupoint_error").scrollIntoView();
    }
});